/*----------------------------------------------------------------------------*/
/* File Information                                                           */
/*----------------------------------------------------------------------------*/
/* Name       : cnet_param.h                                                  */
/* Type       : C Programming Language Header                                 */
/* Version    : E1.00                                                         */
/* Date       : 2006 JUN 22                                                   */
/* CPU        : V850 Family                                                   */
/* About      : NEC Electronics V850 Lightweight Network Protocol Library     */
/*              C-NET Parameter Header                                        */
/*----------------------------------------------------------------------------*/
/* Copyright(C) NEC Electronics 2006                                          */
/* NEC ELECTRONICS CONFIDENTIAL AND PROPRIETARY                               */
/* All rights reserved by NEC Electronics Corporation.                        */
/* Use of copyright notice does not evidence publication                      */
/*----------------------------------------------------------------------------*/

#ifndef __CNET_PARAM_H__
#define __CNET_PARAM_H__

#define	MAXDNSSRVCNT		2
#define	MAXHOSTNAMELEN		64
#define	MAXMAILADDR			64
#define	MAXPOP3ARGLEN		40

#define	MAX_HOSTNAME_LEN	MAXHOSTNAMELEN
#define	MAX_SMTPSERVER_LEN	MAXHOSTNAMELEN
#define	MAX_POP3SERVER_LEN	MAXHOSTNAMELEN
#define	MAX_DOMAINNAME_LEN	MAXHOSTNAMELEN
#define	MAX_POPUSER_LEN		MAXPOP3ARGLEN
#define	MAX_POPPASS_LEN		MAXPOP3ARGLEN
#define	MAX_MAILFROM_LEN	MAXMAILADDR
#define	MAX_MAILTO_LEN		MAXMAILADDR

enum param_id {
	PARAM_MYIP	= 0,
	PARAM_NETMASK,
	PARAM_GATEWAY,
	PARAM_DHCP,
	PARAM_MAIL_DELAY,
	PARAM_HOSTNAME,
	PARAM_SMTP_SERVER,
	PARAM_POP3_SERVER,
	PARAM_DOMAIN,
	PARAM_POP3_USER,
	PARAM_POP3_PASSWORD,
	PARAM_RCV_MAIL_ADDRESS,
	PARAM_FWD_MAIL_ADDRESS
};

int get_param_integer(unsigned char id);
char *get_param_string(unsigned char id);
void set_param_integer(unsigned char id, int value);
void set_param_string(unsigned char id, const char *value, unsigned short len);
void param_load(void);
int param_save(void);

#endif	/* __CNET_PARAM_H__ */
