/*----------------------------------------------------------------------------*/
/* File Information                                                           */
/*----------------------------------------------------------------------------*/
/* Name       : led_tk850_jg2.c                                               */
/* Type       : C Programming Language Source Code                            */
/* Version    : E1.00                                                         */
/* Date       : 2006 APR 20                                                   */
/* CPU        : V850 Family                                                   */
/* About      : NEC Electronics V850 Lightweight Network Protocol Library     */
/*              LED API Source Code for TK-850/JG2+NET                        */
/*----------------------------------------------------------------------------*/
/* Copyright(C) NEC Electronics 2006                                          */
/* NEC ELECTRONICS CONFIDENTIAL AND PROPRIETARY                               */
/* All rights reserved by NEC Electronics Corporation.                        */
/* Use of copyright notice does not evidence publication                      */
/*----------------------------------------------------------------------------*/

#pragma ioreg
/*----------------------------------------------------------------------------*/
void
led_on(unsigned char req)
{
	req ^= 0x0F;
	req |= 0xF0;
	req &= PDH;
	PDH = req;
}
/*----------------------------------------------------------------------------*/
void
led_off(unsigned char req)
{
	req &= 0x0F;
	req |= PDH;
	PDH = req;
}
/*----------------------------------------------------------------------------*/
unsigned char
pushsw_read(void)
{
	return (unsigned char)P5 & 0x03;
}
/*----------------------------------------------------------------------------*/
unsigned char
dipsw_read(void)
{
	return (unsigned char)P7H >> 1;
}
/*----------------------------------------------------------------------------*/
