/******************************************************************************
  Flash memory Self Programming Library for V850
  Header File @(#)flib.h
  Copyright (C) NEC Corporation 2002
  All rights reserved by NEC Corporation. This program must be used solely
  for the purpose for which it was furnished by NEC Corporation. No part
  of this program may be reproduced or disclosed to others, in any form,
  without the prior written permission of NEC Corporation.
 ******************************************************************************/
/*
	Flash Programming Parameters
*/

/* Flash Error code for C interface */
#define	FE_OK					0x00			/* Normal end */
#define	FE_FLMD					0x01			/* Flash Mode error */
#define	FE_PARA					0x05			/* Parameter error */
#define	FE_BUSY					0xff			/* Continue */

#define	ENTRY_RAM_SIZE			124		/* Size of Entry RAM */
#define	ENTRYPOINT	((int(*)(int,...))((struct EntryRamType *)entry_ram)->EntryPoint)


struct FlashEnvData {
	long Frequency;
};


int	FlashEnv( int *entry_ram, struct FlashEnvData *p );
int FlashBlockBlankCheck( int *entry_ram, int block_number );
int FlashBlockErase( int *entry_ram, int block_number );
int FlashBlockIVerify( int *entry_ram, int block_number );
int FlashGetInfo( int *entry_ram, int option );
int FlashFLMDCheck( int *entry_ram );
int FlashStatusCheck( int *entry_ram );
int FlashSetInfo( int *entry_ram, int block_number, char info_flg );
int FlashWordWrite( int *entry_ram, int *address, int *data, int len );
int	FlashBootSwap( int *entry_ram );
int	FlashSetUserHandler( int *entry_ram, int handler_address, void (*handler)() );


/*
 *	Definition of Flash library function
 */
#define	FLE		FlashEnv
#define	FLBBC	FlashBlockBlankCheck
#define	FLBE	FlashBlockErase
#define	FLBIV	FlashBlockIVerify
#define	FLGI	FlashGetInfo
#define	FLFC	FlashFLMDCheck
#define	FLSC	FlashStatusCheck
#define	FLSI	FlashSetInfo
#define	FLWW	FlashWordWrite
#define	FLBS	FlashBootSwap
#define	FLUH	FlashUserHandler

