/*******************************************************************************

	AX88796 hCo

*******************************************************************************/

#include <lwip/sys.h>
#include <lwip/netif.h>
#include <lwip/pbuf.h>
#include <netif/etharp.h>
#include "cnet_lanc.h"

#include "driver/ax88796.H"
#include "driver/NIC_DRV.H"
#include "driver/IODEF.H"


/*----------------------------------------------------------------------------*/
/* Define those to better describe your network interface */
#define	IFNAME0						'e'
#define	IFNAME1						'n'


/* gx[X{[hWX^`wb_ */
#include "driver/cqbb.h"


/* lbg[NRg[䃌WX^\[X */
#define	IO_Adr8		CQBB_LAN_Base8Reg	/* LANRg[x[XAhX(8rbgWX^) */
#define	IO_Adr16	CQBB_LAN_Base16Reg	/* LANRg[x[XAhX(16rbgWX^) */


/* 0obt@Ǘpϐ */
#define SendBuff0_Base	0x4000	/* Mobt@0x[XAhX */
#define SendBuff1_Base	0x4600	/* Mobt@1x[XAhX */

/* Mobt@ZNgϐ */
volatile int	SendBuff_Select;	/* Mobt@I */
volatile int	SendBuff0_Send;		/* Mobt@0tO */
volatile int	SendBuff0_len;		/* Mobt@0MoCg */
volatile int	SendBuff1_Send;		/* Mobt@1tO */
volatile int	SendBuff1_len;		/* Mobt@1MoCg */

/* DP8390Mobt@Ǘpϐ */
#define RecvBuff_Start	0x4C00		/* Mobt@擪AhX */
#define RecvBuff_End	0x8000		/* Mobt@I+1AhX */
volatile int	RecvPacket_Ready;	/* 0ɎMpPbg */
volatile int	RecvBuff_Status;	/* MI[ot[ԃtO */

static err_t NICif_output(struct netif *, struct pbuf *, struct ip_addr *);
static err_t NIC_output(struct netif *, struct pbuf *);
static void NIC_proc(struct netif *);

static unsigned short	nic_status,nic_status_save;
static struct lanc_state		lan_state	= {0};
static unsigned char eth_buff[1514];
/********** NIChCo֐ **********/

/* EEPROMC^[tF[X */
void EEPROM_Init(void)
{
	unsigned char c;
	c=in_byte(IO_Adr8+P0_MII);
	c=c&0x0F;
	out_byte(IO_Adr8+P0_MII,c);	/* 4rbgI[[ */
}

/* EEPROMANZXԑ҂EFCg */
void EEPROM_Wait(void)
{
	in_byte(IO_Adr8+P0_MII);	/* _~[ǂݏo */
}

/* EEPROM`bvZNg */
void EEPROM_ChipSelect(int ctrl)
{
	unsigned char c;
	c=in_byte(IO_Adr8+P0_MII) & 0x0F;
	if (ctrl) {	/* Cl[u */
		c=c|ASIX_EECS;			/* `bvZNgCl[u */
	} else {
		c=c&(~ASIX_EECS);		/* `bvZNgfBZ[u */
	}
	out_byte(IO_Adr8+P0_MII,c);
	EEPROM_Wait();
}

/* EEPROMAhXo͐ */
void EEPROM_Address(int adr)
{
	int i;
	unsigned char c,c0;
	c0=in_byte(IO_Adr8+P0_MII) & 0x0F;
	for(i=5;i>=0;i--){
		c=c0|ASIX_EECS;					/* `bvZNg'1' */
		if (adr&(1<<i)) c=c|ASIX_EEI;	/* AhXrbg'1' */
		out_byte(IO_Adr8+P0_MII,c);		/* CLK = 'L' */
		EEPROM_Wait();
		c=c|ASIX_EECLK;
		out_byte(IO_Adr8+P0_MII,c);		/* CLK = 'H' */
		EEPROM_Wait();
	}
}

/* EEPROMǂݏo */
unsigned int EEPROM_Read(int adr)
{
	int i,code;
	unsigned int d;
	unsigned char c,c0;

	EEPROM_ChipSelect(1);				/* `bvCl[u */

	/* ݂̐|[g̒lۑ */
	c0=in_byte(IO_Adr8+P0_MII) & 0x0F;

	/* ǂݏoR[ho(3rbg) */
	code=0x6;		/* '110' */
	for(i=2;i>=0;i--){
		c=c0|ASIX_EECS;					/* `bvZNg:'1' */
		if (code&(1<<i)) c=c|ASIX_EEI;	/* R[hrbg:'1' */
		out_byte(IO_Adr8+P0_MII,c);		/* CLK = 'L' */
		EEPROM_Wait();
		c=c|ASIX_EECLK;
		out_byte(IO_Adr8+P0_MII,c);		/* CLK = 'H' */
		EEPROM_Wait();
	}

	/* AhXo(6rbg) */
	EEPROM_Address(adr);

	c=c0|ASIX_EECS;						/* `bvZNg'1' */
	out_byte(IO_Adr8+P0_MII,c);			/* CLK = 'L' */
	EEPROM_Wait();

	/* f[^(16rbg) */
	d=0;
	for(i=0;i<16;i++){
		d=d<<1;							/* 1rbgVtg */
		c=c|ASIX_EECLK;
		out_byte(IO_Adr8+P0_MII,c);		/* CLK = 'H' */
		c=in_byte(IO_Adr8+P0_MII);		/* EEOԓ */
		/* NbN̗オGbWŃTvO */
		if (c&ASIX_EEO) d=d|1;
		EEPROM_Wait();
		c=c0|ASIX_EECS;					/* `bvZNg'1' */
		out_byte(IO_Adr8+P0_MII,c);		/* CLK = 'L' */
		EEPROM_Wait();
	}

	EEPROM_ChipSelect(0);				/* `bvfBZ[u */

	return d;
}

/* ԑ҂EFCg */
void Dummy_Wait(void)
{
	unsigned char c;
	unsigned long i;
	for(i=0;i<0x20000;i++){
		c=in_byte(IO_Adr8);
	}
}

/* [gDMAf[^ǂݏo(near pointerobt@p) */
void remoteDMA_read(unsigned short adr, unsigned short len, void *p)
{
	unsigned short i,end,data,*buff;
	if (len==0) return;
	buff=(unsigned short *)p;
	if (len&1) len++;	/* oCg̏ꍇ͂1[hǂݏoKv */
	end=len>>1;
	out_byte(IO_Adr8+P0_RSAR0,adr&0xff);	/* ǂݏoJnAhX() */
	out_byte(IO_Adr8+P0_RSAR1,adr>>8);		/* ǂݏoJnAhX() */
	out_byte(IO_Adr8+P0_RBCR0,len&0xff);	/* ǂݏooCg() */
	out_byte(IO_Adr8+P0_RBCR1,len>>8);		/* ǂݏooCg() */
	out_byte(IO_Adr8+Px_CR,CR_dataread);	/* [gDMA[hJn  */
	for(i=0;i<end;i++){
		data=in_word(IO_Adr16+Px_DATA);		/* f[^|[gǂݏo */
		*buff=data;
		buff++;
	}
}

/* [gDMAf[^ */
void remoteDMA_write(unsigned short adr, unsigned short len, void *p)
{
	unsigned short i,end,data,*buff;
	if (len==0) return;
	buff=(unsigned short *)p;
	if (len&1) len++;	/* oCg̏ꍇ͂1[h݂Kv */
	end=len>>1;
	out_byte(IO_Adr8+P0_RSAR0,adr&0xff);	/* ǂݏoJnAhX() */
	out_byte(IO_Adr8+P0_RSAR1,adr>>8);		/* ǂݏoJnAhX() */
	out_byte(IO_Adr8+P0_RBCR0,len&0xff);	/* ǂݏooCg() */
	out_byte(IO_Adr8+P0_RBCR1,len>>8);		/* ǂݏooCg() */
	out_byte(IO_Adr8+Px_CR,CR_datawrite);	/* [gDMACgJn */
	for(i=0;i<end;i++){
		data=*buff;
		out_word(IO_Adr16+Px_DATA,data);	/* f[^|[g */
		buff++;
	}
}

/********** NIC MACAhXݒ/擾AAPI **********/

/* MACAhXݒ(NICWX^ւ̐ݒ) */
void NIC_SetMACaddress(unsigned char *p)
{
	int i;
/*	CPU_DI;	*/							/* 荞݋֎~ */
	out_byte(IO_Adr8+Px_CR,CR_page1);	/* Regy[W1I */
	for(i=0;i<6;i++){
		out_byte(IO_Adr8+P1_PAR0+i*2,*p);	/* MACAhXݒ */
		p++;
	}
	out_byte(IO_Adr8+Px_CR,CR_page0);	/* Regy[W0I */
/*	CPU_EI;	*/							/* 荞݋ */
}

/* MACAhX擾(NICWX^̎擾) */
void NIC_GetMACaddress(unsigned char *p)
{
	int i;
/*	CPU_DI;	*/							/* 荞݋֎~ */
	out_byte(IO_Adr8+Px_CR,CR_page1);	/* Regy[W1I */
	for(i=0;i<6;i++){
		*p=in_byte(IO_Adr8+P1_PAR0+i*2);	/* MACAhX擾 */
		p++;
	}
	out_byte(IO_Adr8+Px_CR,CR_page0);	/* Regy[W0I */
/*	CPU_EI;	*/							/* 荞݋ */
}


/********** NIC֘AAPI **********/

/* MCl[u/fBZ[u */
void NIC_SendEnableCtrl(int flg)
{
	if (flg == 2) {			/* MCl[u(Sd) */
		/***** ASIXp *****/
		out_byte(IO_Adr8+P0_TCR,TCR_TXFullenable);	/* MCl[u Full duplex */
		out_byte(IO_Adr8+Px_CR,CR_page0 + CR_STA + CR_RD2);	/* N */
	} else if (flg == 1) {	/* MCl[u(d) */
		/***** ASICp *****/
		out_byte(IO_Adr8+P0_TCR,TCR_TXenable);		/* MCl[u Half duplex*/
		out_byte(IO_Adr8+Px_CR,CR_page0 + CR_STA + CR_RD2);	/* N */
	} else {	/* MfBZ[u */
		out_byte(IO_Adr8+P0_TCR,TCR_TXdisable);	/* MfBZ[u */
	}
}

/* MCl[u/fBZ[u */
void NIC_RecvEnableCtrl(int flg)
{
	if (flg) {	/* MCl[u */
		/***** ASIXp *****/
		out_byte(IO_Adr8+P0_RCR,ASIX_RCR_RXenable);	/* MCl[u */
		out_byte(IO_Adr8+Px_CR,CR_page0 + CR_STA + CR_RD2);	/* N */
	} else {	/* MfBZ[u */
		/***** ASIXp *****/
		out_byte(IO_Adr8+P0_RCR,ASIX_RCR_RXdisable);/* MfBZ[u */
	}
}


err_t NICif_Init(struct netif *netif)
{
	if (netif == (struct netif *)0) {
		return ERR_ARG;
	}

	/* initialize lwip network interface */
	netif->name[0] = IFNAME0;
	netif->name[1] = IFNAME1;
	netif->output = NICif_output;
	netif->linkoutput = NIC_output;
	netif->linkproc = NIC_proc;

	/* initialize lan9115 specific interface structure */
	netif->state = &lan_state;

	/* maximum transfer unit */
	netif->mtu = 1500;

	/* broadcast capability */
	netif->flags = NETIF_FLAG_BROADCAST;
  
	/* hardware address length */
	netif->hwaddr_len = 6;

	/* Task beginning */

	etharp_timer_start();

	/* intialize the lan9115 chip */
	return NIC_Init(netif);
}


static void NIC_proc(struct netif *netif)
{
	u16_t	regl;
	u16_t	regh;
	u16_t	w1;
	u16_t	w2;
	u16_t	i;

	while (1) {
		nic_status=NIC_GetStatus();
		if (nic_status!=nic_status_save) {	/* Xe[^XɕωI */
			nic_status_save=nic_status;
			if ((nic_status_save&0x8000)==0) {
				netif->flags &= ~NETIF_FLAG_LINK_UP;
				break;
			} else {
				netif->flags |= NETIF_FLAG_LINK_UP;
			}
		}
		i=NIC_CheckRecvPacket();							/* MpPbg`FbN */
		if (i>0) {
			NIC_GetRecvPacket(netif);
		} else {
			break;
		}
	}
}

static err_t NICif_output(struct netif *netif, struct pbuf *p, struct ip_addr *ipaddr)
{
	p = etharp_output(netif, ipaddr, p);
	/* network hardware address obtained? */
	if (p == (struct pbuf *)0) {
		/* we cannot tell if the packet was sent,    */
		/* the packet could have been queued         */
		/* on an ARP entry that was already pending. */
		return ERR_OK;
	}

	/* send out the packet */
	return NIC_output(netif, p);
}


/* NIC */
int NIC_Init(struct netif *netif)
{
	int i,j;
	unsigned char buff[16],c,*d;
	unsigned short *l;

	/* Zbg */
	out_byte(IO_Adr8+Px_RESET, in_byte(IO_Adr8+Px_RESET));	/* ASIXZbg */
	Dummy_Wait();					/* Jo^C */

	/* MfBZ[uԂŏ */
	out_byte(IO_Adr8+Px_CR,CR_page0 | CR_stop);	/* Regy[W0I/~ */
	out_byte(IO_Adr8+P0_IMR,0);					/* 荞݃}XNNA */
	out_byte(IO_Adr8+P0_ISR,ISR_AllClr);			/* 荞ݗvNA */
	out_byte(IO_Adr8+P0_RBCR0,0);				/* [goCgJEgWX^0NA */
	out_byte(IO_Adr8+P0_RBCR1,0);				/* [goCgJEgWX^1NA */
	out_byte(IO_Adr8+P0_DCR,DCR_fifo8 | DCR_loop | DCR_WTS);	/* [vobN/16rbg] */
	NIC_SendEnableCtrl(0);						/* MfBZ[u */
	NIC_RecvEnableCtrl(0);						/* MfBZ[u */
	out_byte(IO_Adr8+P0_PSTART,(RecvBuff_Start>>8));	/* MNobt@p擪AhX */
	out_byte(IO_Adr8+P0_PSTOP,(RecvBuff_End>>8));/* MNobt@pIAhX */
	out_byte(IO_Adr8+P0_BNRY,(RecvBuff_End>>8)-1);/* E|C^ݒ */

	out_byte(IO_Adr8+Px_CR,CR_page1+CR_STP+CR_RD2);	/* Regy[W1I(ASIX) */

	out_byte(IO_Adr8+P1_CURR,(RecvBuff_Start>>8));/* Jgy[WWX^ݒ */
	out_byte(IO_Adr8+Px_CR,CR_page0);			/* Regy[W0I */

	/* ASIXp */
	EEPROM_Init();			/* EEPROMC^[tF[X */
	/* MACAhXǂݏo */
	j=EEPROM_Read(0);		/* EEPROM0[hړǂݏo */
	buff[0]=(j   )&0xFF;
	buff[1]=(j>>8)&0xFF;
	j=EEPROM_Read(1);		/* EEPROM1[hړǂݏo */
	buff[2]=(j   )&0xFF;
	buff[3]=(j>>8)&0xFF;
	j=EEPROM_Read(2);		/* EEPROM2[hړǂݏo */
	buff[4]=(j   )&0xFF;
	buff[5]=(j>>8)&0xFF;
	/* oCgт̓gGfBA */

	// ac:de:48:00:00:fe
	netif->hwaddr[5] = buff[5];			//0xAC
	netif->hwaddr[4] = buff[4];			//0xDE
	netif->hwaddr[3] = buff[3];			//0x48
	netif->hwaddr[2] = buff[2];			//0x00
	netif->hwaddr[1] = buff[1];			//0x00
	netif->hwaddr[0] = buff[0];			//0xFE

	/* MACAhX I[FFh00h͏G[Ƃ */
	if (
		(buff[0]==0xFF)&&(buff[1]==0xFF)&&(buff[2]==0xFF)&&(buff[3]==0xFF)&&(buff[4]==0xFF)&&(buff[5]==0xFF)
		||
		(buff[0]==0xFF)&&(buff[1]==0xFF)&&(buff[2]==0xFF)&&(buff[3]==0xFF)&&(buff[4]==0xFF)&&(buff[5]==0xFF)
	) return -1;
	/* MACAhXWX^ݒ */
	NIC_SetMACaddress(buff);

	/* eϐ */
	SendBuff_Select=0;
	SendBuff0_Send=0;
	SendBuff1_Send=0;
	RecvPacket_Ready=0;
	RecvBuff_Status=0;

	/* f[^RtBM[VWX^Cl[u */
	out_byte(IO_Adr8+P0_DCR,DCR_fifo8 | DCR_normal | DCR_WTS);	/* ʏ퓮/16rbg] */

	netif->flags |= NETIF_FLAG_LINK_UP;

	NIC_InterruptEnableCtrl(1);
	/* MCl[u/fBZ[u */
	NIC_SendEnableCtrl(1);	/* Cl[u */
	/* MCl[u/fBZ[u */
	NIC_RecvEnableCtrl(1);	/* Cl[u */

	return 0;
}

static err_t NIC_output(struct netif *netif, struct pbuf *p)
{
	struct pbuf	*q	= (struct pbuf *)0;
	union {
		u16_t	*u16;
		u8_t	*u8;
	} ptr;
	union {
		u16_t	u16[2];
		u8_t	u8[4];
	} data;
	u16_t		len;
	u16_t		idx,i,j;

	/* exit if link has failed */
	if (!(netif->flags & NETIF_FLAG_LINK_UP)) {
		return ERR_CONN;
	}

	/* Write Packet */
	idx = 0;
	len	= 0;
	if( p->tot_len==886 ) {
		__nop();
	}
	if( p != (struct pbuf *)0 ) {
		for (q = p; q != (struct pbuf *)0; q = q->next) {
			ptr.u8	= q->payload;
			len		= len + q->len;
			for( i=0 ; i<q->len; i++ ,idx++ ) {
				eth_buff[idx]	= *ptr.u8++;
			}
			if( q->len == q->tot_len ) {
				while(NIC_CheckSendBuffer()==0);
				NIC_SetSendPacket(&eth_buff, len);
				idx = 0;
				len	= 0;
			}
		}
	}

	return ERR_OK;
}


/* NICgpI */
void NIC_Stop(void)
{
	NIC_SendEnableCtrl(0);				/* MfBZ[u */
	NIC_RecvEnableCtrl(0);				/* MfBZ[u */
	out_byte(IO_Adr8+Px_CR, CR_stop);	/* ~ */
}

/* NICXe[^X擾 */
unsigned short NIC_GetStatus(void)
{
	unsigned short i;
	unsigned char status;
	/***** ASIXp *****/
	status=in_byte(IO_Adr8+P0_GPI);	/* fBAԊmF */
	switch (status & 0x7) {
		case 7:
			i=0x8008;				/* 100Base-TX Full */
			NIC_SendEnableCtrl(2);	/* Full duplex */
			break;
		case 5:
			i=0x8004;				/* 100Base-TX Half */
			NIC_SendEnableCtrl(1);	/* Half duplex */
			break;
		case 3:
			i=0x8002;				/* 10Base-T Full */
			NIC_SendEnableCtrl(2);	/* Full duplex */
			break;
		case 1:
			i=0x8001;				/* 10Base-T Half */
			NIC_SendEnableCtrl(1);	/* Half duplex */
			break;
		default:
			i=0;
			break;
	}
	return i;
}




/********** MpPbg֘AAPI **********/

/* pPbgMJn */
void SendStart(unsigned short BuffBase, unsigned short len)
{
/*	CPU_DI;	*/	/* 荞݋֎~ */
	out_byte(IO_Adr8+P0_TPSR,BuffBase>>8);	/* MJnobt@xy[WAhX */
	out_byte(IO_Adr8+P0_TBCR0,len&0xff);		/* MJnoCg() */
	out_byte(IO_Adr8+P0_TBCR1,len>>8);		/* MJnoCg() */
	out_byte(IO_Adr8+Px_CR,CR_page0 | CR_sendstart);	/* Regy[W0I/MJn */
/*	CPU_EI;	*/	/* 荞݋ */
}

/* MpPbg */
int NIC_SetSendPacket(unsigned char *buff, unsigned short len)
{
	if (len<60)   len=60;	/* ŏ60oCg(FCStōŏ64oCg) */
	if (len>1514) len=1514;	/* ő1514oCg(FCStōő1518oCg) */

	if (SendBuff_Select==0) {			/* ̑MɑMobt@0g */

		if (SendBuff0_Send==0) {		/* Mobt@0󂢂Ă */
/*			CPU_DI;	*/					/* 荞݋֎~ */
			remoteDMA_write(SendBuff0_Base, len, buff);	/* [gDMAőMobt@0ɏ */
			SendBuff0_len=len;			/* Mobt@0MoCgۑ */
			if (SendBuff1_Send==-1) {	/* Mobt@1M */
				SendBuff0_Send=1;		/* Mobt@0MJnۗ */
			} else {
				SendBuff0_Send=-1;		/* Mobt@0MJn */
				SendStart(SendBuff0_Base, SendBuff0_len);	/* MJn */
			}
			SendBuff_Select=1;			/* ͑Mobt@1g */
/*			CPU_EI;	*/					/* 荞݋ */
			return 0;					/* Mobt@i[ */
		} else {
			return -1;					/* Mobt@󂢂ĂȂ */
		}

	} else {
		if (SendBuff1_Send==0) {		/* Mobt@1󂢂Ă */
/*			CPU_DI;	*/					/* 荞݋֎~ */
			remoteDMA_write(SendBuff1_Base, len, buff);	/* [gDMAőMobt@1ɏ */
			SendBuff1_len=len;			/* Mobt@1MoCgۑ */
			if (SendBuff0_Send==-1) {	/* Mobt@0M */
				SendBuff1_Send=1;		/* Mobt@1MJnۗ */
			} else {
				SendBuff1_Send=-1;		/* Mobt@1MJn */
				SendStart(SendBuff1_Base, SendBuff1_len);	/* MJn */
			}
			SendBuff_Select=0;			/* ͑Mobt@0g */
/*			CPU_EI;	*/					/* 荞݋ */
			return 0;					/* Mobt@i[ */
		} else {
			return -1;					/* Mobt@󂢂ĂȂ */
		}

	}
}

/* Mobt@󂫏ԃ`FbN */
int NIC_CheckSendBuffer(void)
{
	if (SendBuff_Select==0) {	/* ̑MɑMobt@0g */
		if (SendBuff0_Send==0) {/* Mobt@0󂢂Ă */
			return 1;	/* Mobt@󂢂Ă */
		} else {
			return 0;	/* Mobt@󂢂ĂȂ */
		}
	} else {					/* ̑MɑMobt@1g */
		if (SendBuff1_Send==0) {/* Mobt@1󂢂Ă */
			return 1;	/* Mobt@󂢂Ă */
		} else {
			return 0;	/* Mobt@󂢂ĂȂ */
		}
	}
}

/* MpPbgMXe[^X擾 */
int NIC_GetSendPacketStatus(void)
{
	return 0;
	/* 󑗐MG[Ȃ̂... */
}




/********** MpPbg֘AAPI **********/

/* MpPbgL`FbN */
int NIC_CheckRecvPacket(void)
{
	if (RecvBuff_Status==2) return -1;
	/* Mobt@I[ot[  -1 */
	return RecvPacket_Ready;
	/* hCoMobt@ɎMpPbg 1 */
	/* hCoMobt@ɎMpPbgȂ 0 */
}

/* MpPbgo */
unsigned short NIC_GetRecvPacket(struct netif *netif)
//unsigned short NIC_GetRecvPacket(unsigned char *buff)
{
	struct pbuf	*p	= (struct pbuf *)0;
	struct pbuf	*q	= (struct pbuf *)0;
	union {
		u16_t	*u16;
		u8_t	*u8;
	} ptr;
	union {
		u16_t	u16[2];
		u8_t	u8[4];
	} data;
	u16_t		idx;

	unsigned char CURR,BNRY,work[4];
	unsigned short StartAdr,len,i,j;
	unsigned short adr, end;

	RecvBuff_Status=0;

	if (RecvPacket_Ready==0) {	/* Mf[^Ȃ */
		return 0;
	}

/*	CPU_DI;	*/							/* 荞݋֎~ */
	out_byte(IO_Adr8+Px_CR,CR_page1);	/* Regy[W1I */
	CURR=in_byte(IO_Adr8+P1_CURR);		/* Jgy[WWX^ */
	out_byte(IO_Adr8+Px_CR,CR_page0);	/* Regy[W0I */
/*	CPU_EI;	*/							/* 荞݋ */
	BNRY=in_byte(IO_Adr8+P0_BNRY);		/* E|C^y[WWX^ */

	if (
		( (CURR==(RecvBuff_Start>>8)) && (BNRY==(RecvBuff_End>>8)-1) )
	 ||
		( (BNRY+1)==CURR )
	) {
		RecvPacket_Ready=0;	/* MpPbgo */
		return 0;			/* MpPbgf[^Ȃ */
	}

	/* Mobt@RAMpPbgf[^o */
	/* oobt@擪AhXvZ */
	if (BNRY==(RecvBuff_End>>8)-1) StartAdr=RecvBuff_Start;
	else StartAdr=(BNRY+1)<<8;

	remoteDMA_read(StartAdr, 4, work);		/* 擪4oCgǂݏo */
	len=(work[2]|(work[3]<<8))-4;			/* c̃oCg */

	p = pbuf_alloc(PBUF_LINK, len , PBUF_POOL);
	if (p == (struct pbuf *)0) {
		return 0;
	}

	adr	= StartAdr+4;
	/* Read Packet */
	if (p->tot_len&1) {	/* oCg̏ꍇ͂1[hǂݏoKv */
		end	= (p->tot_len+1) >> 1;
	} else {
		end	= p->tot_len >> 1;
	}
	out_byte(IO_Adr8+P0_RSAR0,adr&0xff);	/* ǂݏoJnAhX() */
	out_byte(IO_Adr8+P0_RSAR1,adr>>8);		/* ǂݏoJnAhX() */
	out_byte(IO_Adr8+P0_RBCR0,len&0xff);	/* ǂݏooCg() */
	out_byte(IO_Adr8+P0_RBCR1,len>>8);		/* ǂݏooCg() */
	out_byte(IO_Adr8+Px_CR,CR_dataread);	/* [gDMA[hJn  */
	idx = 0;
	for (q = p; q != (struct pbuf *)0; q = q->next) {
		ptr.u16 = q->payload;
		len = q->len;
		if (idx > 0) {
			while (len > 0) {
				*ptr.u8 = data.u8[idx];
				ptr.u8++;
				len--;
				if (idx >= 1) {
					idx = 0;
					break;
				}
				idx++;
			}
		}
		while (len > 1) {
			*ptr.u16=in_word(IO_Adr16+Px_DATA);		/* f[^|[gǂݏo */
			ptr.u16++;
			len -= 2;
		}
		if (len > 0) {
			data.u16[0] = in_word(IO_Adr16+Px_DATA);
			do {
				*ptr.u8 = data.u8[idx];
				ptr.u8++;
				idx++;
				len--;
			} while (len > 0);
		}
	}

	BNRY=work[1]-1;	/* ̎Mobt@(Jgy[W)̎Oɐݒ */
	if (BNRY==(RecvBuff_Start>>8)-1) BNRY=(RecvBuff_End>>8)-1;
	out_byte(IO_Adr8+P0_BNRY,BNRY);		/* VE|C^ʒuɏ */

	if (
		( (CURR==(RecvBuff_Start>>8)) && (BNRY==(RecvBuff_End>>8)-1) )
	 ||
		( (BNRY+1)==CURR )
	) {
		RecvPacket_Ready=0;	/* MpPbgo */
	}
	/* ̏ȂƂ́ApPbgMobt@RAMɊi[Ăꍇ */
	/* RecvPacket_ReadyNA1pPbg̏邽߂ɂ̊֐𔲂 */

	idx = htons(((struct eth_hdr *)p->payload)->type);
	if (idx == ETHTYPE_IP) {
		/* IP packet */
		/* update ARP table, obtain first queued packet */
		etharp_ip_input(netif, p);
		/* skip Ethernet header */
		pbuf_header(p, -14);
		/* pass to network layer */
		netif->input(p, netif);
	} else if (idx == ETHTYPE_ARP) {
		/* ARP packet */
		/* pass p to ARP module, get ARP reply or ARP queued packet */
		etharp_arp_input(netif, (struct eth_addr *)&netif->hwaddr, p);
	} else {
		/* unsupported Ethernet packet type */
		/* free pbuf */
		pbuf_free(p);
	}
	/* send out the ARP reply or ARP queued packet */
	if (q != (struct pbuf *)0) {
		NIC_output(netif, q);
		pbuf_free(q);
	}

	return len;
}




/********** 荞݊֘AAPI **********/

/* NIC荞݃Cl[u/fBZ[u */
void NIC_InterruptEnableCtrl(int flg)
{
/* NIC_Initł炩foCXĂ̂ŁA*/
/* ł͎gp銄荞ݗṽ}XNLq */

	if (flg) {
		out_byte(IO_Adr8+P0_ISR,0xFF);	/* 荞݃Xe[^XNA */
		/* pPbgM/pPbgM/Mobt@I[o[t[荞 荞݃}XN */
		out_byte(IO_Adr8+P0_IMR,IMR_PRXE | IMR_PTXE | IMR_OVWE);
	} else {
		out_byte(IO_Adr8+P0_IMR,0);	/* S荞݃fBZ[u */
	}
}

/* NIC荞ݏ */
void NIC_Interrupt(void)
{
	unsigned char Status;
	Status=in_byte(IO_Adr8+P0_ISR);	/* 荞݃Xe[^X擾 */
	out_byte(IO_Adr8+P0_ISR,Status);	/* 荞݃Xe[^XNA */

	/* M֘A荞 */
	if (Status&(ISR_PTX | ISR_TXE)) {
		if (Status&ISR_PTX) {			/* M荞 */
			if (SendBuff0_Send==-1) {	/* Mobt@0M */
				SendBuff0_Send=0;		/* Mobt@0M */
				if (SendBuff1_Send==1) {/* Mobt@1Mۗ */
					SendBuff1_Send=-1;	/* Mobt@1MJn */
					SendStart(SendBuff1_Base, SendBuff1_len);	/* MJn */
				}
			}
			if (SendBuff1_Send==-1) {	/* Mobt@1M */
				SendBuff1_Send=0;		/* Mobt@1M */
				if (SendBuff0_Send==1) {/* Mobt@0Mۗ */
					SendBuff0_Send=-1;	/* Mobt@0MJn */
					SendStart(SendBuff0_Base, SendBuff0_len);	/* MJn */
				}
			}
		} else {					/* MG[荞 */
			/* {hCoł͊荞݂͔Ȃ */
		}
	}

	if (Status&(ISR_PRX | ISR_RXE)) {	/* M֘A荞 */
		if (Status&ISR_PRX) {			/* M荞 */
			RecvPacket_Ready++;

		} else {						/* MG[荞 */
			/* {hCoł͊荞݂͔Ȃ */
		}
	}

	/* Mobt@I[o[t[荞ݏ */
	if (Status&ISR_OVW) {
		while(in_byte(IO_Adr8+Px_CR)&CR_TXP) {}	/* MȂ瑗M܂ő҂ */
		/* Mobt@̓e͔jI */
		out_byte(IO_Adr8+Px_CR, CR_stop);				/* ~ */
		Dummy_Wait();
		out_byte(IO_Adr8+P0_BNRY,(RecvBuff_End>>8)-1);	/* E|C^ݒ */
		out_byte(IO_Adr8+Px_CR,CR_page1);				/* Regy[W1I */
		out_byte(IO_Adr8+P1_CURR,(RecvBuff_Start>>8));	/* Jgy[WWX^ݒ */
		out_byte(IO_Adr8+Px_CR,CR_page0 | CR_STA);		/* Regy[W0IN */
		RecvPacket_Ready=0;	/* DP8390ɎMpPbg͖ */
		RecvBuff_Status=2;	/* Mobt@I[ot[ */
	}

}
